PROGRAM NAG_test
  IMPLICIT NONE
  INTEGER :: n, ifail, iter, i, iuser(1)
  REAL :: objf, user(1)
  REAL, DIMENSION(:), ALLOCATABLE :: x, objgrd, work
  INTEGER, DIMENSION(:), ALLOCATABLE :: iwork 
  EXTERNAL e04dge, e04dke, fun
  n = 1000
  ALLOCATE(x(n), objgrd(n), work(13*n), iwork(n+1))
  ! Alkuarvaus ratkaisulle
  x(1:n-1:2) = (/ (-1.2d0 - 0.1d0*COS(REAL(i)), i=1,n-1,2) /)
  x(2:n:2) = 1.d0 + 0.1d0*COS(x(1:n-1:2))
  ! Parametrit ratkaisurutiinille
  CALL e04dke('   Maximum step length = 100')
  CALL e04dke('   Optimality tolerance = 1.0d-14')
  CALL e04dke('   Iteration limit = 1000')
  CALL e04dke('   Print level = 1')
  ifail = -1 
  CALL e04dge(n, fun, iter, objf, objgrd, x, iwork, &
      work, iuser, user, ifail)
  WRITE(*,*) 'Minimiarvo: ', objf
END PROGRAM NAG_test

! Minimoitava funktio ja gradienttivektori
SUBROUTINE fun(mode, n, x, objf, objgrd, nstate, iuser, user)
  IMPLICIT NONE
  INTEGER, INTENT(IN) :: mode, n, nstate
  INTEGER, DIMENSION(:), INTENT(IN) :: iuser
  REAL, DIMENSION(n), INTENT(IN) :: x
  REAL, DIMENSION(:), INTENT(IN) :: user
  REAL, INTENT(OUT) :: objf
  REAL, DIMENSION(SIZE(x)), INTENT(OUT) :: objgrd
  INTEGER :: i
  REAL ::  t1, t2
  objf = 0.d0
  DO i = 1, n-1, 2
    t1 = 1.d0 - x(i); t2 = 10.d0*(x(i+1) - x(i)**2)
    ! Kohdefunktion arvo
    objf = objf + t1**2 + t2**2
    ! Gradienttivektori
    objgrd(i+1) = 20.d0*t2
    objgrd(i) = -2.d0*(x(i)*objgrd(i+1) + t1)
  END DO
END SUBROUTINE fun

SUBROUTINE objfun(mode,n,x,objf,objgrd,nstate)
  ! Kohdefunktio ja gradienttivektori
  IMPLICIT NONE
  REAL, INTENT(OUT) :: objf
  INTEGER, INTENT(IN) :: mode, n, nstate
  REAL, DIMENSION(n), INTENT(IN) :: x
  REAL, DIMENSION(n), INTENT(OUT) :: objgrd
  objf = (x(1)-2.0d0)**2 + (x(2)-1.0d0)**2
  objgrd(1) = 2.0d0*(x(1)-2.0d0)
  objgrd(2) = 2.0d0*(x(2)-1.0d0)
END SUBROUTINE objfun

SUBROUTINE confun(mode,ncnln,n,nrowj,x,c,cjac,nstate)
  ! Rajoitteet ja Jacobin matriisi
  IMPLICIT NONE
  INTEGER, INTENT(IN) :: mode, ncnln, n, nrowj, nstate
  REAL, DIMENSION(n), INTENT(IN) :: x
  REAL, DIMENSION(nrowj), INTENT(OUT) :: c
  REAL, DIMENSION(nrowj,n), INTENT(INOUT) :: cjac
  ! Alustetaan Jacobin matriisi
  IF (nstate == 1) cjac(1:ncnln,1:n) = 0.0d0
  ! Epälineaarinen rajoite 1
  c(1) = -(x(1)**2)/4.0d0 - x(2)**2
  ! Jacobin matriisin rivi 1
  cjac(1,1) = -0.5d0*x(1)
  cjac(1,2) = -2.0d0*x(2)
END SUBROUTINE confun

PROGRAM SQP_test
  IMPLICIT NONE
  INTEGER :: n, nclin, ncnln, nctotl, nrowa, nrowj, nrowr, &
      liwork, lwork, i, ifail, iter, itmax, j, mode, msglvl, &
      nstate
  INTEGER, DIMENSION(:), ALLOCATABLE :: istate, iwork
  LOGICAL :: cold, fealin, ortho
  REAL :: bigbnd, epsaf, epsmch, eta, ftol, objf, rteps
  REAL, DIMENSION(:,:), ALLOCATABLE :: a, cjac, r
  REAL, DIMENSION(:), ALLOCATABLE :: x, bl, bu, c, clamda, &
      featol, objgrd, work, x02aje
  EXTERNAL x02aje, confun, e04vce, e04zce, objfun
  ! Asetetaan tehtävän dimensiot
  n = 2; nclin = 1; ncnln = 1; nctotl = n+nclin+ncnln
  nrowa = nclin; nrowj = ncnln; nrowr = n
  liwork = 3*n+nclin+2*ncnln
  lwork = 2*n*n+n*nclin+2*n*ncnln+20*n+11*nclin+21*ncnln
  ALLOCATE(a(nrowa,n), bl(nctotl), bu(nctotl), c(nrowj), &
      cjac(nrowj,n), clamda(nctotl), featol(nctotl), &
      objgrd(n), r(nrowr,n), work(lwork), x(n), &
      istate(nctotl), iwork(liwork))
  ! Alkuasetukset
  nstate = 1; mode = 1; ifail = 1; msglvl = 1
  bigbnd = 1.d10; itmax = 100; eta = 0.9d0
  x = (/ 2.d0,2.d0 /); a = RESHAPE((/1.d0,-2.d0/), (/1,2/))
  bl = (/ -10.d0,-5.d0,-1.d0,-1.d0 /)
  bu = (/ 10.d0,5.d0,-1.d0,1.d10 /)
  cold = .TRUE.; fealin = .TRUE.; ortho = .TRUE.
  ifail = 1  ! Tarkistetaan gradientit
  CALL e04zce(n, nclin, nrowj, confun, objfun, c, cjac, &
      objf, objgrd, x, work, lwork, ifail)
  IF (ifail == 0) THEN  ! Gradienttivektori on ok...
    epsmch = x02aje() ! Selvitetään laskentatarkkuus
    ftol = 10.0d0*epsmch; rteps = SQRT(epsmch)
    featol(1:nctotl) = rteps
    CALL objfun(mode, n, x, objf, objgrd, nstate)
    epsaf = epsmch*ABS(objf)
    ifail = 1  ! Ratkaistaan tehtävä
    CALL e04vce(itmax, msglvl, n, nclin, ncnln, nctotl, &
        nrowa, nrowj, nrowr, bigbnd, epsaf, eta, ftol, a, &
        bl, bu, featol, confun, objfun, cold, fealin, ortho, &
        x, istate, r, iter, c, cjac, objf, objgrd, clamda, &
        iwork, liwork, work, lwork, ifail)
    IF (ifail /= 0) WRITE(*,*) 'e04vce:n ifail =', ifail
  ELSE
    WRITE(*,*) 'Virhe gradienttivektorissa. ifail =', ifail
  END IF
END PROGRAM SQP_test

PROGRAM QR_test
  IMPLICIT NONE
  INTEGER :: m, n, lwork, i, j, info
  REAL, DIMENSION(:,:), ALLOCATABLE :: a
  REAL, DIMENSION(:), ALLOCATABLE :: tau, work
  CHARACTER*(*), PARAMETER :: form = '(6(2x,f8.6))'

  m = 6; n = 2; lwork = 2*m
  ALLOCATE(a(m,m), tau(MIN(m,n)), work(lwork))
  a = 0.d0
  a(:,1) = (/ 1.d0, 0.d0, 1.d0, 0.d0, 1.d0, 0.d0 /)
  a(:,2) = (/ 0.d0, 1.d0, 0.d0, 1.d0, 0.d0, 1.d0 /)
  CALL sgeqrf(m, n, a, m, tau, work, lwork, info)
  CALL sorgqr(m, m, MIN(m,n), a, m, tau, work, lwork, info)
  WRITE (*,form) a
END PROGRAM QR_test

PROGRAM Lapack_test
  IMPLICIT NONE
  INTEGER :: n, nrhs, lwork, j, info
  INTEGER, DIMENSION(:), ALLOCATABLE :: ipiv
  CHARACTER, PARAMETER :: uplo = 'u'
  REAL, DIMENSION(:), ALLOCATABLE :: x, gx, work
  REAL, DIMENSION(:,:), ALLOCATABLE :: hx
  REAL :: fx, xdiff, xtol
  ! Muuttujien alustus
  n = 2; nrhs = 1; lwork = n*n
  ALLOCATE(x(n), gx(n), hx(n,n), ipiv(n), work(lwork))
  x = (/ -1.2d0, 1.0d0 /) ! Alkuarvaus
  xdiff = 1.d0; xtol = 1.d-7
  j = 0
  ! Tehdään Newton-iteraatioita
  DO WHILE (xdiff > xtol)
    CALL derivfn(x, fx, gx, hx); WRITE(*,*) x, fx
    ! Ratkaistaan Newton-yhtälö Lapackilla
    CALL ssysv(uplo, n, nrhs, hx, n, ipiv, gx, n, &
        work, lwork, info)
    IF (info /= 0) STOP 'Hessen matriisi singulaarinen'
    x(:) = x(:) - gx(:)
    xdiff = SQRT(SUM(gx(:)**2))
    j = j + 1
  END DO
  WRITE(*,*) 'x = ', x, '; fx = ', fx, '; iter = ', j
CONTAINS
  SUBROUTINE derivfn(x, fx, gx, hx)
    IMPLICIT NONE
    REAL, DIMENSION(:), INTENT(IN) :: x
    REAL, INTENT(OUT) :: fx
    REAL, DIMENSION(SIZE(x)), INTENT(OUT) :: gx
    REAL, DIMENSION(SIZE(x),SIZE(x)), INTENT(OUT) :: hx
    ! Funktion arvo
    fx = 100.d0*(x(2) - x(1)**2)**2 + (1.d0 - x(1))**2
    ! Gradienttivektori
    gx(1) = -400.d0*x(1)*(x(2) - x(1)**2) + 2.d0*(x(1) - 1)
    gx(2) = 200.d0*(x(2) - x(1)**2)
    ! Hessen matriisin yläkolmio
    hx(1,1) = 1200.d0*x(1)**2 - 400.d0*x(2) + 2.d0
    hx(1,2) = -400.d0*x(1)
    hx(2,2) = 200.d0
  END SUBROUTINE derivfn
END PROGRAM Lapack_test

PROGRAM IMSL_test
  IMPLICIT NONE
  INTEGER :: n, i, maxfcn
  REAL :: ftol, fx, s
  REAL, DIMENSION(:), ALLOCATABLE ::x, x0
  EXTERNAL fcn, umpol

  n = 2
  ALLOCATE(x(n), x0(n))
  x0(1:n-1:2) = -1.2d0
  x0(2:n:2) = 1.0d0

  ftol = 1.0d-10
  maxfcn = 1000*n**2
  s = 1.0

  CALL umpol(fcn, n, x0, s, ftol, maxfcn, x, fx)

  WRITE(*,*) 'x = ', x
  WRITE(*,*) 'fx = ', fx, '; iter = ', maxfcn
END PROGRAM IMSL_test

SUBROUTINE fcn(n, x, f)
  ! Minimoitava funktio
  IMPLICIT NONE
  INTEGER, INTENT(IN) :: n
  REAL, DIMENSION(n), INTENT(IN) :: x
  REAL, INTENT(OUT) :: f
  INTEGER :: i
  REAL ::  t1, t2
  f = 0.d0
  DO i = 1, n-1, 2
    t1 = 1.d0 - x(i); t2 = 10.d0*(x(i+1) - x(i)**2)
    ! Kohdefunktion arvo
    f = f + t1**2 + t2**2
  END DO
END SUBROUTINE fcn
